SystemOrganization addCategory: #'Database-Abstraction-LayerGOODS'!

!DALObject methodsFor: '*database-abstraction-layergoods' stamp: 'JohanBrichau 5/31/2011 20:40'!
markAsChanged: aSymbol
	self goodsChanged.
	versionStamp ifNil:[versionStamp := DALAbstractDAO current createVersionStamp].
	versionStamp := versionStamp + 1.! !

!DALObjectIDCounter methodsFor: '*Database-Abstraction-LayerGOODS' stamp: 'AndyKellens 4/10/2011 17:22'!
markAsChanged: aSymbol
	self goodsChanged ! !

DALExternalSession subclass: #DALGoodsSession
	instanceVariableNames: 'inTransaction transactionLevel registrationCache withRetryCache resourceUseCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Database-Abstraction-LayerGOODS'!

!DALGoodsSession class methodsFor: 'factory methods' stamp: 'JohanBrichau 12/7/2010 14:45'!
createDictionary 
	^KKDictionary new.! !

!DALGoodsSession class methodsFor: 'factory methods' stamp: 'ThomasCleenewerck 2/8/2011 16:20'!
createDirectory: aPath
	^(FileDirectory on: aPath) assureExistence! !

!DALGoodsSession class methodsFor: 'factory methods' stamp: 'JohanBrichau 12/7/2010 14:45'!
createOrderedCollection 
	^KKOrderedCollection new! !

!DALGoodsSession class methodsFor: 'factory methods' stamp: 'AndyKellens 12/14/2010 20:40'!
createRcDictionary 
	^KKDictionary new.! !

!DALGoodsSession class methodsFor: 'factory methods' stamp: 'AndyKellens 12/14/2010 20:40'!
createRcOrderedCollection 
	^KKOrderedCollection new! !

!DALGoodsSession class methodsFor: 'factory methods' stamp: 'AndyKellens 12/14/2010 20:40'!
createRcSet
	^KKSet new! !

!DALGoodsSession class methodsFor: 'factory methods' stamp: 'JohanBrichau 12/7/2010 14:45'!
createSet
	^KKSet new! !

!DALGoodsSession class methodsFor: 'factory methods' stamp: 'JohanBrichau 4/21/2011 11:13'!
createVersionStamp
	^0! !

!DALGoodsSession class methodsFor: 'factory methods' stamp: 'JohanBrichau 12/7/2010 14:47'!
databaseException 
	^KKCommitFailure! !

!DALGoodsSession methodsFor: 'private' stamp: 'AndyKellens 12/14/2010 20:43'!
bringUpToDate 
	nativeSession refresh! !

!DALGoodsSession methodsFor: 'public' stamp: 'AndyKellens 12/17/2010 20:00'!
commit
	nativeSession commit! !

!DALGoodsSession methodsFor: 'private' stamp: 'JohanBrichau 12/7/2010 21:34'!
createNativeSession
	^KKDatabase onHost:(dao class host) port:(dao class port)! !

!DALGoodsSession methodsFor: 'public' stamp: 'AndyKellens 12/17/2010 21:43'!
disconnect 
	nativeSession isConnected ifTrue:[nativeSession logout]! !

!DALGoodsSession methodsFor: 'public' stamp: 'AndyKellens 2/5/2011 11:54'!
executeAsTransaction: aTransactionBlock
	inTransaction ifFalse:[nativeSession emptyWriteBarrier].
	transactionLevel := transactionLevel + 1.
	inTransaction := true.
	[aTransactionBlock value.  transactionLevel := transactionLevel - 1] on:Error do:[:exp | registrationCache := OrderedCollection new. withRetryCache := OrderedCollection new. transactionLevel := 0. inTransaction := false.  resourceUseCache := OrderedCollection new. ^exp signal].
	transactionLevel = 0 ifTrue:[| id |
			inTransaction := false.
			[nativeSession commit] on: Exception do:[:exp | registrationCache := OrderedCollection new.  transactionLevel := 0. withRetryCache := OrderedCollection new. resourceUseCache := OrderedCollection new. exp signal.].
			id := self increaseUniqueIdentifiersWith: (registrationCache size). "Ask the session to create all unique IDs in bulk"
			nativeSession commitWithRetry:[ "Execute all blocks, passing in the unique id if the block is a registration block"
				withRetryCache do:[:block | 
					block value: ((registrationCache includes: block) 
										ifTrue:[id at: (registrationCache indexOf: block)] 
										ifFalse:[nil])]. "Perform all the retry-able operations"].
				registrationCache := OrderedCollection new.
				withRetryCache := OrderedCollection new.
				resourceUseCache := OrderedCollection  new.
				nativeSession flush]
								
! !

!DALGoodsSession methodsFor: 'public' stamp: 'AndyKellens 12/15/2010 21:46'!
hasData 	
	| tempSession result |
	"To know whether there already is data we need to create a new native session due to some peculiarities of GOODS"
	tempSession := self createNativeSession.
	result := tempSession root ~= nil.
	tempSession logout.
	^result! !

!DALGoodsSession methodsFor: 'private' stamp: 'JohanBrichau 1/25/2011 13:36'!
increaseUniqueIdentifier 
	| id |
	nativeSession commitWithRetry:[ id := (dao root at:#UniqueIdentifier) increase].
	^id
	! !

!DALGoodsSession methodsFor: 'private' stamp: 'JohanBrichau 1/25/2011 13:37'!
increaseUniqueIdentifiersWith: aNumber
	| id |
	nativeSession commitWithRetry:[ id := (dao root at:#UniqueIdentifier) increaseWith:aNumber].
	^id
	! !

!DALGoodsSession methodsFor: 'initialization' stamp: 'AndyKellens 2/5/2011 11:53'!
initializeWithDAO: aDAO 
	inTransaction := false.
	transactionLevel := 0.
	registrationCache := OrderedCollection new.
	withRetryCache := OrderedCollection new.
	resourceUseCache := OrderedCollection new.
	super initializeWithDAO: aDAO! !

!DALGoodsSession methodsFor: 'private' stamp: 'AndyKellens 2/5/2011 11:46'!
registrationOperation: aBlock forObject: anObject
	| theID |
	"Check if the object is actually reregistered"
	"If this is the case, then reuse the old ID"
	theID := anObject uniqueIdentifier isNilID ifTrue:[anObject uniqueIdentifier oldID] ifFalse:[nil].
	inTransaction ifTrue:
			[ | block |
			block := [:id | anObject uniqueIdentifier: (theID ifNil:[id] ifNotNil:[theID]). "We get the unique ID from the bulk operation"
							self putObjectInHash: anObject. "Put the object in the hash"
					aBlock value ].
			registrationCache add: block.
			withRetryCache add: block]
		ifFalse:
			[ anObject uniqueIdentifier: (theID ifNil:[self increaseUniqueIdentifier] ifNotNil:[theID]). "Outside a transaction, immediately fill out the unique ID"
			   self putObjectInHash: anObject. "Put the object in the hash"
			nativeSession commitWithRetry: aBlock]! !

!DALGoodsSession methodsFor: 'public' stamp: 'AndyKellens 12/14/2010 21:47'!
resourceUseCache 
	^resourceUseCache ! !

!DALGoodsSession methodsFor: 'public' stamp: 'JohanBrichau 12/7/2010 15:05'!
rollback
	nativeSession rollback! !

!DALGoodsSession methodsFor: 'public' stamp: 'JohanBrichau 12/7/2010 15:00'!
root 
	^nativeSession root! !

!DALGoodsSession methodsFor: 'public' stamp: 'JohanBrichau 12/7/2010 21:38'!
root: anObject
	^nativeSession root: anObject! !

!DALGoodsSession methodsFor: 'private' stamp: 'AndyKellens 2/5/2011 11:46'!
unregistrationOperation: aBlock forObject: anObject
	| newID |
	anObject uniqueIdentifier isNilID 
		ifTrue:[newID := anObject uniqueIdentifier]
		ifFalse:[
		newID := DALNilID new.
		newID oldID: (anObject uniqueIdentifier)].
	inTransaction 
		ifTrue: [ 
				withRetryCache add: [:ignore |
					aBlock value. 
					self removeObjectFromHash: anObject. 
					anObject uniqueIdentifier: newID]]
		ifFalse: [ 
			nativeSession commitWithRetry: [
				aBlock value. 
				self removeObjectFromHash: anObject. 
				anObject uniqueIdentifier: newID] ]
		
	! !

!DALGoodsSession methodsFor: 'public' stamp: 'AndyKellens 2/5/2011 11:46'!
withRetryOperation: aBlock
	"Register an operation that needs a retry and should never be leading to a commit failure"
	^inTransaction ifTrue:
			[withRetryCache  add: [:ignore | aBlock value]]
		ifFalse:
			[nativeSession  commitWithRetry: aBlock ]! !
